Attribute VB_Name = "Object"
Public Sub MoveForward(Unit, Distance)
    Dim Ang As Integer, xx As Integer, yy As Integer, ZZ As Integer
    Ang = World(Unit).Angle.y Mod 360
    Vang = World(Unit).Angle.x Mod 360
    yy = SINe(Vang) * Distance
    xx = SINe(Ang) * (COSine(Vang) * Distance)
    ZZ = COSine(Ang) * (COSine(Vang) * Distance)
    World(Unit).Origin.x = World(Unit).Origin.x + xx
    World(Unit).Origin.y = World(Unit).Origin.y - yy
    World(Unit).Origin.z = World(Unit).Origin.z + ZZ
End Sub

Public Sub MoveBackward(Unit, Distance)
    Dim Ang As Integer, xx As Integer, ZZ As Integer
    Ang = World(Unit).Angle.y
    xx = SINe(Ang) * Distance
    ZZ = COSine(Ang) * Distance
    World(Unit).Origin.x = World(Unit).Origin.x - xx
    World(Unit).Origin.z = World(Unit).Origin.z - ZZ
End Sub

Public Sub TurnLeft(Unit, Angle)
    World(Unit).Angle.y = World(Unit).Angle.y - Angle
    World(Unit).Angle.y = World(Unit).Angle.y Mod 360
    If World(Unit).Angle.y < 0 Then World(Unit).Angle.y = World(Unit).Angle.y + 360
End Sub

Public Sub TurnRight(Unit, Angle)
    World(Unit).Angle.y = World(Unit).Angle.y + Angle
    World(Unit).Angle.y = World(Unit).Angle.y Mod 360
    If World(Unit).Angle.y > 360 Then World(Unit).Angle.y = World(Unit).Angle.y - 360
End Sub


Public Sub FireWeapon(Unit, Weapon)
    
    For n = 1 To Model(World(Unit).ModelID).WeaponCount
        If Model(World(Unit).ModelID).Weapon(n).Name = Weapon Then
            Add = GetNewFloat
            World(Add).Used = True
            JJ = Model(World(Unit).ModelID).Weapon(n).Joint
            
            World(Add).Origin.x = World(Unit).Node(JJ).x + World(Unit).Origin.x
            World(Add).Origin.y = -World(Unit).Node(JJ).y + World(Unit).Origin.y
            World(Add).Origin.z = -World(Unit).Node(JJ).z + World(Unit).Origin.z
            
            World(Add).Angle = World(Unit).Angle
            
            World(Add).Angle.x = World(Unit).Morph(2).Angle.x
            
            
            World(Add).ModelID = 4
            World(Add).UnitID = 4
            World(Add).Timer = 70
   
            
        End If
    Next n
End Sub

Public Sub ThrowGib(Unit)
    Add = GetNewFloat
    World(Add).Origin = World(Unit).Origin
    World(Add).Angle = World(Unit).Angle
    If Rnd > 0.5 Then World(Add).ModelID = 3 Else World(Add).ModelID = 4
    Hang = Int(Rnd * 360):    Vang = Int(Rnd * 90): Speed = 20
    World(Add).GibSpeed.x = SINe(Hang) * (COSine(Vang) * Speed)
    World(Add).GibSpeed.y = SINe(Vang) * Speed
    World(Add).GibSpeed.z = COSine(Hang) * (COSine(Vang) * Speed)
    World(Add).UnitID = 5
    World(Add).Timer = 30
    World(Add).Used = True
End Sub


Public Sub ThrowDust(Unit, Joint, Style)
    Add = GetNewFloat
    World(Add).Used = True
    JJ = Model(World(Unit).ModelID).Weapon(n).Joint
    World(Add).Origin.x = World(Unit).Node(JJ).x + World(Unit).Origin.x + World(Unit).Node(Joint).x
    World(Add).Origin.y = -World(Unit).Node(JJ).y - World(Unit).Origin.y + World(Unit).Node(Joint).y
    World(Add).Origin.z = -World(Unit).Node(JJ).z + World(Unit).Origin.z - World(Unit).Node(Joint).z
    World(Add).Angle = World(Unit).Angle
    World(Add).Angle.x = World(Unit).Morph(2).Angle.x
    
    If Style = 1 Then
        World(Add).ModelID = 255
        World(Add).UnitID = 255
        World(Add).Timer = 20
        World(Add).Size = 10
    End If
    
    If Style = 2 Then
        World(Add).ModelID = 255
        World(Add).UnitID = 254
        World(Add).Timer = 20
        World(Add).Size = 10
    End If

    If Style = 3 Then
        World(Add).ModelID = 255
        World(Add).UnitID = 253
        World(Add).Timer = 20
        World(Add).Size = 20
    End If

    If Style = 4 Then
        World(Add).ModelID = 255
        World(Add).UnitID = 252
        World(Add).Timer = 20
        World(Add).Size = 20
    End If
    
End Sub


